// THE POOR'S MAN CONSOLE
// ARDU-MAN
// wwww.bleepbit.com
// (C) 2018

// LIBRAY
#include <Wire.h>
#include <VirtualWire.h>
#include <LiquidCrystal_I2C.h>
LiquidCrystal_I2C lcd(0x27,16,2);

// VARIABLES DECLARATION
int game = 0;
int cc = 2;
int mov = 0;
int gameover = 0;
int le = 0;
int randomNumber = 0;
int labirinth[11][2];
int ay = 0;
int ax = 0;
int x = 0;
int y = 0;
int incx = 0;
int incy = 0;
int key = LOW;
int timegame = 2000;
int pills = 16;

// CHARS DECLARATION
byte left[8] = {
  B11111,
  B00001,
  B10000,
  B11000,
  B10000,
  B00001,
  B11111,
  B11111,
};
  byte right[8] = {
  B11111,
  B10000,
  B00001,
  B00011,
  B00001,
  B10000,
  B11111,
  B11111,
};
  byte circle[8] = {
  B11111,
  B10001,
  B00000,
  B00000,
  B00000,
  B10001,
  B11111,
  B11111,
};
  byte lab[8] = {
  B00000,
  B00000,
  B00000,
  B00000,
  B00000,
  B00000,
  B00000,
  B00000,
};
  byte pin[8] = {
  B11111,
  B11111,
  B11111,
  B11011,
  B11111,
  B11111,
  B11111,
  B11111,
};
  byte nothing[8] = {
  B11111,
  B11111,
  B11111,
  B11111,
  B11111,
  B11111,
  B11111,
  B11111,
};
 byte crash[8] = {
B10001,
B01000,
B10001,
B01000,
B00010,
B10001,
B00100,
B01001,
};
 byte happy[8] = {
B10001,
B00000,
B01010,
B00000,
B01110,
B00100,
B10001,
B11111,
};


 
void setup(){
  lcd.init();
  lcd.backlight();
  lcd.home();
  lcd.clear();
  lcd.createChar(1, left);
  lcd.createChar(2, right);
  lcd.createChar(3, circle);  
  lcd.createChar(4, lab);
  lcd.createChar(5, pin);
  lcd.createChar(6, nothing);
  lcd.createChar(7, crash);
  lcd.createChar(8, happy);
}

  
void loop(){
  if (game == 0)
  {
    if (gameover == 0)
      {
      // SPLASH SCREEN
        lcd.home();
        lcd.setCursor(0, 0);
        lcd.print("    ARDU-MAN");
        lcd.setCursor(0, 1);
        lcd.print(" bleepbit  2018"); 
        // lcd.print("poor man's game"); 
        key = digitalRead(7);
        if (key == LOW)
        {
        // START GAME
        lcd.clear();
        lcd.home();
        le = 0;
        gameover = 1;
        } 
       }
     else
       {
           // NEW SCREEN
            ay = 0;
            ax = 0;
            x = 0;
            y = 0;
            incx = 0;
            incy = 0;
            game = 1;
            key = LOW;
            cc = 2;
            le = le + 1;
            pills = 16;
           randomSeed(analogRead(0));
           for(int i=0;i<2;i++)
           {
             for(int s=0;s<11;s++)
             {
             lcd.setCursor(s, i);
             labirinth[s][i] = 0;
             lcd.write(byte(5));         
             }
           }
          for(int s=2;s<11;s=s+2)
             {
             randomNumber = int(random(0, 2));
             lcd.setCursor(s, randomNumber);
             labirinth[s][randomNumber] = 2;
             lcd.write(byte(4));         
            }
           lcd.setCursor(0, 1);
           labirinth[0][1] = 2;
           lcd.write(byte(4));
           lcd.setCursor(12, 0);
           lcd.print("L 00");
           lcd.setCursor(16-String(le).length(), 0);
           lcd.print(le);
           lcd.setCursor(12, 1);
           lcd.print("0000");
           timegame = 2000;
     }
  }
  else
  {
    
  // GAME LOOP
  lcd.home();
  lcd.setCursor(x, y);
  lcd.write(byte(6)); 
  x = x + incx;
  y = y + incy;
  incx = 0;
  incy = 0;

  // CHECK LIVE OR DIE
  if ((labirinth[x][y] < 2) && (timegame > 1))
  {

  if (labirinth[x][y] == 0)
      {
      pills = pills - 1;
      labirinth[x][y] = 1;
      }
      
  lcd.setCursor(x, y);
  if (mov == 1)
  {
    lcd.write(byte(cc));
    mov = 0;
  }
  else
  {
  lcd.write(byte(3));
  mov = 1;
  }
  ay = analogRead(1);   
  ax = analogRead(0);
  if ((ax >600)  && (x<10))
  {
    incx = 1;
    incy = 0;
    cc = 2;
  }
  
  if ((ax < 200) && (x>0))
  {
    incx = -1;
    incy = 0;
    cc = 1;
  }
  
  if ((ay <200) && (y == 1))
  {
    incx = 0;
    incy = -1;
  }
  
  if ((ay > 500) && (y == 0))
  {
    incx = 0;
    incy = 1;
  }

 timegame = timegame - le*10;
  lcd.setCursor(12, 1);
  lcd.print("0000");
  lcd.setCursor(16-String(timegame).length(), 1);
  lcd.print(timegame);
  delay(200);

  // CHECK LEVEL CLEAR
      if (pills == 0)
      {
      // LEVEL CLEAR
        lcd.setCursor(x, y);
  lcd.write(byte(8)); 
      lcd.setCursor(12, 0);
      lcd.print("NEXT");
      lcd.setCursor(12, 1);
      lcd.print("LEVL");
      delay(3000);
      lcd.clear();    
      game = 0;
      gameover = 1;
      }
  
    // END GAME LOOP
  }
  else
  {
  //  GAME OVER
  if (timegame>0)
  {
   lcd.setCursor(x, y);
  lcd.write(byte(7)); 
  }
  lcd.setCursor(12, 0);
  lcd.print("GAME");
  lcd.setCursor(12, 1);
  lcd.print("OVER");
  delay(4000);
  lcd.clear();    
  game = 0;
  gameover =0;
  }



  }
}


